# coding: utf-8

"""
    Nuon

    API for managing nuon apps, components, and installs.

    The version of the OpenAPI document: 0.19.105
    Contact: support@nuon.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json




from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from nuon.models.service_create_install_request_aws_account import ServiceCreateInstallRequestAwsAccount
from nuon.models.service_create_install_request_azure_account import ServiceCreateInstallRequestAzureAccount
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class ServiceCreateInstallRequest(BaseModel):
    """
    ServiceCreateInstallRequest
    """ # noqa: E501
    aws_account: Optional[ServiceCreateInstallRequestAwsAccount] = None
    azure_account: Optional[ServiceCreateInstallRequestAzureAccount] = None
    inputs: Optional[Dict[str, StrictStr]] = None
    name: StrictStr
    __properties: ClassVar[List[str]] = ["aws_account", "azure_account", "inputs", "name"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of ServiceCreateInstallRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of aws_account
        if self.aws_account:
            _dict['aws_account'] = self.aws_account.to_dict()
        # override the default output from pydantic by calling `to_dict()` of azure_account
        if self.azure_account:
            _dict['azure_account'] = self.azure_account.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of ServiceCreateInstallRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "aws_account": ServiceCreateInstallRequestAwsAccount.from_dict(obj.get("aws_account")) if obj.get("aws_account") is not None else None,
            "azure_account": ServiceCreateInstallRequestAzureAccount.from_dict(obj.get("azure_account")) if obj.get("azure_account") is not None else None,
            "inputs": obj.get("inputs"),
            "name": obj.get("name")
        })
        return _obj


